diff --git a/gcc/analyzer/region-model.h b/gcc/analyzer/region-model.h
index e5d04b47e0d..f75625fbe48 100644
--- a/gcc/analyzer/region-model.h
+++ b/gcc/analyzer/region-model.h
@@ -2374,176 +2322,176 @@ public:
 
   store_manager *get_store_manager () { return &m_store_mgr; }
 
-  /* Dynamically-allocated region2 instances.
+  /* Dynamically-allocated region instances.
      FIXME: for now, the number of these within the analysis can grow
      arbitrarily.  They are still owned by the manager.  */
-  const region2 *create_region_for_heap_alloc ();
-  const region2 *create_region_for_alloca (const frame_region2 *frame);
+  const region *create_region_for_heap_alloc ();
+  const region *create_region_for_alloca (const frame_region *frame);
 
   void log_stats (logger *logger, bool show_objs) const;
 
 private:
   bool too_complex_p (const complexity &c) const;
-  bool reject_if_too_complex (svalue2 *sval);
+  bool reject_if_too_complex (svalue *sval);
 
-  const svalue2 *maybe_fold_unaryop (tree type, enum tree_code op,
-				     const svalue2 *arg);
-  const svalue2 *maybe_fold_binop (tree type, enum tree_code op,
-				   const svalue2 *arg0, const svalue2 *arg1);
-  const svalue2 *maybe_fold_sub_svalue2 (tree type,
-					 const svalue2 *parent_svalue,
-					 const region2 *subregion);
+  const svalue *maybe_fold_unaryop (tree type, enum tree_code op,
+				     const svalue *arg);
+  const svalue *maybe_fold_binop (tree type, enum tree_code op,
+				   const svalue *arg0, const svalue *arg1);
+  const svalue *maybe_fold_sub_svalue (tree type,
+					 const svalue *parent_svalue,
+					 const region *subregion);
 
   unsigned m_next_region_id;
-  root_region2 m_root_region;
-  stack_region2 m_stack_region;
-  heap_region2 m_heap_region;
+  root_region m_root_region;
+  stack_region m_stack_region;
+  heap_region m_heap_region;
 
-  /* svalue2 consolidation.  */
-  typedef hash_map<tree, constant_svalue2 *> constants_map_t;
+  /* svalue consolidation.  */
+  typedef hash_map<tree, constant_svalue *> constants_map_t;
   constants_map_t m_constants_map;
 
-  typedef hash_map<tree, unknown_svalue2 *> unknowns_map_t;
+  typedef hash_map<tree, unknown_svalue *> unknowns_map_t;
   unknowns_map_t m_unknowns_map;
-  const unknown_svalue2 *m_unknown_NULL;
+  const unknown_svalue *m_unknown_NULL;
 
-  typedef hash_map<poisoned_svalue2::key_t,
-		   poisoned_svalue2 *> poisoned_values_map_t;
+  typedef hash_map<poisoned_svalue::key_t,
+		   poisoned_svalue *> poisoned_values_map_t;
   poisoned_values_map_t m_poisoned_values_map;
 
-  typedef hash_map<setjmp_svalue2::key_t,
-		   setjmp_svalue2 *> setjmp_values_map_t;
+  typedef hash_map<setjmp_svalue::key_t,
+		   setjmp_svalue *> setjmp_values_map_t;
   setjmp_values_map_t m_setjmp_values_map;
 
-  typedef hash_map<const region2 *, initial_svalue2 *> initial_values_map_t;
+  typedef hash_map<const region *, initial_svalue *> initial_values_map_t;
   initial_values_map_t m_initial_values_map;
 
-  typedef hash_map<const region2 *, region_svalue2 *> pointer_values_map_t;
+  typedef hash_map<const region *, region_svalue *> pointer_values_map_t;
   pointer_values_map_t m_pointer_values_map;
 
-  typedef hash_map<unaryop_svalue2::key_t,
-		   unaryop_svalue2 *> unaryop_values_map_t;
+  typedef hash_map<unaryop_svalue::key_t,
+		   unaryop_svalue *> unaryop_values_map_t;
   unaryop_values_map_t m_unaryop_values_map;
 
-  typedef hash_map<binop_svalue2::key_t, binop_svalue2 *> binop_values_map_t;
+  typedef hash_map<binop_svalue::key_t, binop_svalue *> binop_values_map_t;
   binop_values_map_t m_binop_values_map;
 
-  typedef hash_map<sub_svalue2::key_t, sub_svalue2 *> sub_values_map_t;
+  typedef hash_map<sub_svalue::key_t, sub_svalue *> sub_values_map_t;
   sub_values_map_t m_sub_values_map;
 
-  typedef hash_map<const svalue2 *,
-		   unmergeable_svalue2 *> unmergeable_values_map_t;
+  typedef hash_map<const svalue *,
+		   unmergeable_svalue *> unmergeable_values_map_t;
   unmergeable_values_map_t m_unmergeable_values_map;
 
-  typedef hash_map<widening_svalue2::key_t,
-		   widening_svalue2 */*,
-	           widening_svalue2::key_t::hash_map_traits*/>
+  typedef hash_map<widening_svalue::key_t,
+		   widening_svalue */*,
+		   widening_svalue::key_t::hash_map_traits*/>
     widening_values_map_t;
   widening_values_map_t m_widening_values_map;
 
-  typedef hash_map<compound_svalue2::key_t,
-		   compound_svalue2 *> compound_values_map_t;
+  typedef hash_map<compound_svalue::key_t,
+		   compound_svalue *> compound_values_map_t;
   compound_values_map_t m_compound_values_map;
 
-  typedef hash_map<conjured_svalue2::key_t,
-		   conjured_svalue2 *> conjured_values_map_t;
+  typedef hash_map<conjured_svalue::key_t,
+		   conjured_svalue *> conjured_values_map_t;
   conjured_values_map_t m_conjured_values_map;
 
   /* Maximum complexity of svalues that weren't rejected.  */
   complexity m_max_complexity;
 
-  /* region2 consolidation.  */
+  /* region consolidation.  */
 
-  code_region2 m_code_region;
-  typedef hash_map<tree, function_region2 *> fndecls_map_t;
+  code_region m_code_region;
+  typedef hash_map<tree, function_region *> fndecls_map_t;
   typedef fndecls_map_t::iterator fndecls_iterator_t;
   fndecls_map_t m_fndecls_map;
 
-  typedef hash_map<tree, label_region2 *> labels_map_t;
+  typedef hash_map<tree, label_region *> labels_map_t;
   typedef labels_map_t::iterator labels_iterator_t;
   labels_map_t m_labels_map;
 
-  globals_region2 m_globals_region;
-  typedef hash_map<tree, decl_region2 *> globals_map_t;
+  globals_region m_globals_region;
+  typedef hash_map<tree, decl_region *> globals_map_t;
   typedef globals_map_t::iterator globals_iterator_t;
   globals_map_t m_globals_map;
 
-  uniq_manager<region2> m_fields;
+  uniq_manager<region> m_fields;
 #if 0
-  struct field_key_t { region2 *m_parent; tree m_field; };
-  typedef hash_map<field_key_t, region2 *> fields_map_t;
+  struct field_key_t { region *m_parent; tree m_field; };
+  typedef hash_map<field_key_t, region *> fields_map_t;
   fields_map_t m_fields_map;
 #endif
-  uniq_manager<region2> m_elements;
-  uniq_manager<region2> m_offset_regions;
-  uniq_manager<region2> m_cast_regions;
-  uniq_manager<frame_region2> m_frames;
-  uniq_manager<region2> m_symbolic_regions;
+  uniq_manager<region> m_elements;
+  uniq_manager<region> m_offset_regions;
+  uniq_manager<region> m_cast_regions;
+  uniq_manager<frame_region> m_frames;
+  uniq_manager<region> m_symbolic_regions;
 
-  typedef hash_map<tree, string_region2 *> string_map_t;
+  typedef hash_map<tree, string_region *> string_map_t;
   string_map_t m_string_map;
 
   store_manager m_store_mgr;
 
-  /* "Dynamically-allocated" region2 instances.
+  /* "Dynamically-allocated" region instances.
      FIXME: for now, the number of these within the analysis can grow
      arbitrarily.  They are still owned by the manager.  */
-  auto_delete_vec<region2> m_managed_dynamic_regions;
+  auto_delete_vec<region> m_managed_dynamic_regions;
 };
 
 struct append_ssa_names_cb_data;
 
 /* Helper class for handling calls to functions with known behavior.
-   Implemented in region-model2-impl-calls.c.  */
+   Implemented in region-model-impl-calls.c.  */
 
 class call_details
 {
 public:
-  call_details (const gcall *call, region_model2 *model,
-		region_model2_context *ctxt);
+  call_details (const gcall *call, region_model *model,
+		region_model_context *ctxt);
 
-  region_model2_context *get_ctxt () const { return m_ctxt; }
+  region_model_context *get_ctxt () const { return m_ctxt; }
   tree get_lhs_type () const { return m_lhs_type; }
-  const region2 *get_lhs_region () const { return m_lhs_region; }
+  const region *get_lhs_region () const { return m_lhs_region; }
 
-  bool maybe_set_lhs (const svalue2 *result) const;
+  bool maybe_set_lhs (const svalue *result) const;
 
   tree get_arg_tree (unsigned idx) const;
-  const svalue2 *get_arg_svalue2 (unsigned idx) const;
+  const svalue *get_arg_svalue (unsigned idx) const;
 
   void dump_to_pp (pretty_printer *pp, bool simple) const;
   void dump (bool simple) const;
 
 private:
   const gcall *m_call;
-  region_model2 *m_model;
-  region_model2_context *m_ctxt;
+  region_model *m_model;
+  region_model_context *m_ctxt;
   tree m_lhs_type;
-  const region2 *m_lhs_region;
+  const region *m_lhs_region;
 };
 
-/* A region_model2 encapsulates a representation of the state of memory, with
-   a tree of region2s, along with their associated values.
+/* A region_model encapsulates a representation of the state of memory, with
+   a tree of regions, along with their associated values.
    The representation is graph-like because values can be pointers to
-   region2s.
+   regions.
    It also stores a constraint_manager, capturing relationships between
    the values.  */
 
-class region_model2
+class region_model
 {
  public:
-  region_model2 (region_model2_manager *mgr);
-  region_model2 (const region_model2 &other);
-  ~region_model2 ();
+  region_model (region_model_manager *mgr);
+  region_model (const region_model &other);
+  ~region_model ();
 
 #if 0//__cplusplus >= 201103
   region_model2 (region_model2 &&other);
 #endif
 
-  region_model2 &operator= (const region_model2 &other);
+  region_model &operator= (const region_model &other);
 
-  bool operator== (const region_model2 &other) const;
-  bool operator!= (const region_model2 &other) const
+  bool operator== (const region_model &other) const;
+  bool operator!= (const region_model &other) const
   {
     return !(*this == other);
   }
@@ -2567,26 +2515,26 @@ class region_model2
   void validate () const;
 
   bool on_stmt (const gimple *stmt,
-		region_model2_context *ctxt);
+		region_model_context *ctxt);
   bool on_gassign (const gassign *stmt,
-		   region_model2_context *ctxt);
-  const svalue2 * get_gassign_result (const gassign *assign,
-				      region_model2_context *ctxt);
+		   region_model_context *ctxt);
+  const svalue * get_gassign_result (const gassign *assign,
+				      region_model_context *ctxt);
 #if 0
   bool on_gcall (const supernode *snode,
 		 const gcall *stmt);
 #else
-  bool on_call_pre (const gcall *stmt, region_model2_context *ctxt);
+  bool on_call_pre (const gcall *stmt, region_model_context *ctxt);
   void on_call_post (const gcall *stmt,
 		     bool unknown_side_effects,
-		     region_model2_context *ctxt);
+		     region_model_context *ctxt);
 
   /* Specific handling for on_call_pre.  */
   bool impl_call_alloca (const call_details &cd);
   void impl_call_analyzer_describe (const gcall *call,
-				    region_model2_context *ctxt);
+				    region_model_context *ctxt);
   void impl_call_analyzer_eval (const gcall *call,
-				region_model2_context *ctxt);
+				region_model_context *ctxt);
   bool impl_call_builtin_expect (const call_details &cd);
   bool impl_call_calloc (const call_details &cd);
   void impl_call_free (const call_details &cd);
@@ -2595,215 +2543,163 @@ class region_model2
   bool impl_call_strlen (const call_details &cd);
 #endif
   void handle_unrecognized_call (const gcall *call,
-				 region_model2_context *ctxt);
-  void get_reachable_svalues (svalue2_set *out,
-			      const svalue2 *extra_sval);
+				 region_model_context *ctxt);
+  void get_reachable_svalues (svalue_set *out,
+			      const svalue *extra_sval);
   bool on_greturn (const greturn *stmt,
-		   region_model2_context *ctxt);
+		   region_model_context *ctxt);
   void on_setjmp (const gcall *stmt, const exploded_node *enode,
-		  region_model2_context *ctxt);
+		  region_model_context *ctxt);
   void on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
-		   int setjmp_stack_depth, region_model2_context *ctxt);
+		   int setjmp_stack_depth, region_model_context *ctxt);
 
   void update_for_phis (const supernode *snode,
 			const cfg_superedge *last_cfg_superedge,
-			region_model2_context *ctxt);
+			region_model_context *ctxt);
 
   void handle_phi (const gphi *phi,
 		   tree lhs, tree rhs, bool is_back_edge,
-		   region_model2_context *ctxt);
+		   region_model_context *ctxt);
 
   bool maybe_update_for_edge (const superedge &edge,
 			      const gimple *last_stmt,
-			      region_model2_context *ctxt);
+			      region_model_context *ctxt);
 
-  const region2 *push_frame (function *fun, vec<const svalue2 *> *arg_sids,
-			     region_model2_context *ctxt);
-  const frame_region2 *get_current_frame () const { return m_current_frame; }
+  const region *push_frame (function *fun, vec<const svalue *> *arg_sids,
+			     region_model_context *ctxt);
+  const frame_region *get_current_frame () const { return m_current_frame; }
   function * get_current_function () const;
-  void pop_frame (const region2 *result_dst,
-		  bool purge, purge_stats2 *stats,
-		  const svalue2 **out_result,
-		  region_model2_context *ctxt);
+  void pop_frame (const region *result_dst,
+		  bool purge, purge_stats *stats,
+		  const svalue **out_result,
+		  region_model_context *ctxt);
   int get_stack_depth () const;
-  const frame_region2 *get_frame_at_index (int index) const;
-
-#if 0
-  void replace_svalue2 (svalue2_id sid, const svalue2 *new_sval);
-#endif
+  const frame_region *get_frame_at_index (int index) const;
 
-  const region2 *get_lvalue (path_var pv, region_model2_context *ctxt);
-  const region2 *get_lvalue (tree expr, region_model2_context *ctxt);
-  const svalue2 *get_rvalue (path_var pv, region_model2_context *ctxt);
-  const svalue2 *get_rvalue (tree expr, region_model2_context *ctxt);
+  const region *get_lvalue (path_var pv, region_model_context *ctxt);
+  const region *get_lvalue (tree expr, region_model_context *ctxt);
+  const svalue *get_rvalue (path_var pv, region_model_context *ctxt);
+  const svalue *get_rvalue (tree expr, region_model_context *ctxt);
 
+  const region *deref_rvalue (const svalue *ptr_sval, tree ptr_tree,
+			       region_model_context *ctxt);
 #if 0
-  svalue2_id maybe_cast (tree type, svalue2_id sid, region_model2_context *ctxt);
-  svalue2_id maybe_cast_1 (tree type, svalue2_id sid);
-
-  region2_id get_field_region2 (region2_id rid, tree field,
-			      region_model2_context *ctxt);
-#endif
-
-  const region2 *deref_rvalue (const svalue2 *ptr_sval, tree ptr_tree,
-			       region_model2_context *ctxt);
-#if 0
-  const region2 *deref_rvalue (tree ptr, region_model2_context *ctxt);
+  const region *deref_rvalue (tree ptr, region_model_context *ctxt);
 #endif
 
-  void set_value (const region2 *lhs_reg, const svalue2 *rhs_sval,
-		  region_model2_context *ctxt);
-  void set_value (tree lhs, tree rhs, region_model2_context *ctxt);
-  void clobber_region (const region2 *reg);
-  void purge_region (const region2 *reg);
-  void zero_fill_region (const region2 *reg);
-  void mark_region_as_unknown (const region2 *reg);
+  void set_value (const region *lhs_reg, const svalue *rhs_sval,
+		  region_model_context *ctxt);
+  void set_value (tree lhs, tree rhs, region_model_context *ctxt);
+  void clobber_region (const region *reg);
+  void purge_region (const region *reg);
+  void zero_fill_region (const region *reg);
+  void mark_region_as_unknown (const region *reg);
 
 #if 0
-  const svalue2 *set_to_new_unknown_value (const region2 *dst_reg, tree type,
-				     region_model2_context *ctxt);
+  const svalue *set_to_new_unknown_value (const region *dst_reg, tree type,
+				     region_model_context *ctxt);
 #endif
-  void copy_region (const region2 *dst_reg, const region2 *src_reg,
-		    region_model2_context *ctxt);
-  tristate eval_condition (const svalue2 *lhs,
+  void copy_region (const region *dst_reg, const region *src_reg,
+		    region_model_context *ctxt);
+  tristate eval_condition (const svalue *lhs,
 			   enum tree_code op,
-			   const svalue2 *rhs) const;
-  tristate eval_condition_without_cm (const svalue2 *lhs,
+			   const svalue *rhs) const;
+  tristate eval_condition_without_cm (const svalue *lhs,
 				      enum tree_code op,
-				      const svalue2 *rhs) const;
-  tristate compare_initial_and_pointer (const initial_svalue2 *init,
-					const region_svalue2 *ptr) const;
+				      const svalue *rhs) const;
+  tristate compare_initial_and_pointer (const initial_svalue *init,
+					const region_svalue *ptr) const;
   tristate eval_condition (tree lhs,
 			   enum tree_code op,
 			   tree rhs,
-			   region_model2_context *ctxt);
+			   region_model_context *ctxt);
   bool add_constraint (tree lhs, enum tree_code op, tree rhs,
-		       region_model2_context *ctxt);
-#if 0
-  region2_id add_new_malloc_region2 ();
-#endif
-  const region2 *create_region_for_heap_alloc (const svalue2 *size_in_bytes);
-  const region2 *create_region_for_alloca (const svalue2 *size_in_bytes);
+		       region_model_context *ctxt);
+  const region *create_region_for_heap_alloc (const svalue *size_in_bytes);
+  const region *create_region_for_alloca (const svalue *size_in_bytes);
 
-  tree get_representative_tree (const svalue2 *sval) const;
+  tree get_representative_tree (const svalue *sval) const;
 #if 0
-  void get_path_vars_for_svalue2 (const svalue2 *sval,
+  void get_path_vars_for_svalue (const svalue *sval,
 				  auto_vec<path_var> *out) const;
 #endif
   path_var
-  get_representative_path_var (const svalue2 *sval,
-			       hash_set <const svalue2 *> *visited) const;
+  get_representative_path_var (const svalue *sval,
+			       hash_set <const svalue *> *visited) const;
   path_var
-  get_representative_path_var (const region2 *reg,
-			       hash_set <const svalue2 *> *visited) const;
+  get_representative_path_var (const region *reg,
+			       hash_set <const svalue *> *visited) const;
 
-#if 0
-  void purge_unused_svalue2s (purge_stats *out,
-			     region_model2_context *ctxt,
-			     svalue2_id_set *known_used_sids = NULL);
-  void purge_region2s (const region2_id_set &set,
-		      purge_stats *stats,
-		      logger *logger);
-#endif
   /* For selftests.  */
-  constraint_manager2 *get_constraints2 ()
+  constraint_manager *get_constraints ()
   {
-    return m_constraints2;
+    return m_constraints;
   }
 
   store *get_store () { return &m_store; }
   const store *get_store () const { return &m_store; }
 
-  region_model2_manager *get_manager () const { return m_mgr; }
+  region_model_manager *get_manager () const { return m_mgr; }
 
-#if 0
-  void get_descendents (region2_id rid, region2_id_set *out,
-			region2_id exclude_rid) const;
-#endif
-
-  void unbind_region2_and_descendents (const region2 *reg,
+  void unbind_region_and_descendents (const region *reg,
 				       enum poison_kind pkind,
-				       purge_stats2 *stats,
+				       purge_stats *stats,
 				       logger *logger);
 
-  bool can_merge_with_p (const region_model2 &other_model,
+  bool can_merge_with_p (const region_model &other_model,
 			 const program_point &point,
-			 region_model2 *out_model) const;
-#if 0
-  svalue2_id get_value_by_name (const char *name) const;
-
-  svalue2_id convert_byte_offset_to_array_index (tree ptr_type,
-						svalue2_id offset_sid);
-
-  region2_id get_or_create_mem_ref (tree type,
-				   svalue2_id ptr_sid,
-				   svalue2_id offset_sid,
-				   region_model2_context *ctxt);
-  region2_id get_or_create_pointer_plus_expr (tree type,
-					     svalue2_id ptr_sid,
-					     svalue2_id offset_sid,
-					     region_model2_context *ctxt);
-  region2_id get_or_create_view (region2_id raw_rid, tree type,
-				region_model2_context *ctxt);
-#endif
+			 region_model *out_model) const;
+
   tree get_fndecl_for_call (const gcall *call,
-			    region_model2_context *ctxt);
+			    region_model_context *ctxt);
 
   void get_ssa_name_regions_for_current_frame
-    (auto_vec<const decl_region2 *> *out) const;
-  static void append_ssa_names_cb (const region2 *base_reg,
+    (auto_vec<const decl_region *> *out) const;
+  static void append_ssa_names_cb (const region *base_reg,
 				   struct append_ssa_names_cb_data *data);
 
-  const svalue2 *get_store_value (const region2 *reg) const;
+  const svalue *get_store_value (const region *reg) const;
 
-  bool region_exists_p (const region2 *reg) const;
+  bool region_exists_p (const region *reg) const;
 
   void canonicalize ();
   bool canonicalized_p () const;
 
-  void loop_replay_hack (const region_model2 *dst_state);
+  void loop_replay_hack (const region_model *dst_state);
 
 private:
-  const region2 *get_lvalue_1 (path_var pv,
-			       region_model2_context *ctxt);
-  const svalue2 *get_rvalue_1 (path_var pv,
-			       region_model2_context *ctxt);
+  const region *get_lvalue_1 (path_var pv,
+			       region_model_context *ctxt);
+  const svalue *get_rvalue_1 (path_var pv,
+			       region_model_context *ctxt);
 
-#if 0
-  void copy_struct_region2 (region2_id dst_rid, struct_region2 *dst_reg,
-			   struct_region2 *src_reg, region_model2_context *ctxt);
-  void copy_union_region2 (region2_id dst_rid, union_region2 *src_reg,
-			  region_model2_context *ctxt);
-  void copy_array_region2 (region2_id dst_rid, array_region2 *dst_reg,
-			  array_region2 *src_reg, region_model2_context *ctxt);
-#endif
   void add_any_constraints_from_ssa_def_stmt (tree lhs,
 					      enum tree_code op,
 					      tree rhs,
-					      region_model2_context *ctxt);
+					      region_model_context *ctxt);
   void add_any_constraints_from_gassign (enum tree_code op,
 					 tree rhs,
 					 const gassign *assign,
-					 region_model2_context *ctxt);
+					 region_model_context *ctxt);
   void add_any_constraints_from_gcall (enum tree_code op,
 				       tree rhs,
 				       const gcall *call,
-				       region_model2_context *ctxt);
+				       region_model_context *ctxt);
 
   void update_for_call_superedge (const call_superedge &call_edge,
-				  region_model2_context *ctxt);
+				  region_model_context *ctxt);
   void update_for_return_superedge (const return_superedge &return_edge,
-				    region_model2_context *ctxt);
+				    region_model_context *ctxt);
   void update_for_call_summary (const callgraph_superedge &cg_sedge,
-				region_model2_context *ctxt);
+				region_model_context *ctxt);
   bool apply_constraints_for_gcond (const cfg_superedge &edge,
 				    const gcond *cond_stmt,
-				    region_model2_context *ctxt);
+				    region_model_context *ctxt);
   bool apply_constraints_for_gswitch (const switch_cfg_superedge &edge,
 				      const gswitch *switch_stmt,
-				      region_model2_context *ctxt);
+				      region_model_context *ctxt);
 
-  int poison_any_pointers_to_descendents (const region2 *reg,
+  int poison_any_pointers_to_descendents (const region *reg,
 					  enum poison_kind pkind);
 
 #if 0
@@ -2811,44 +2707,34 @@ private:
 				      auto_vec<path_var> *rep_path_vars,
 				      bool *is_first);
 #endif
-  void on_top_level_param (tree param, region_model2_context *ctxt);
+  void on_top_level_param (tree param, region_model_context *ctxt);
 
-  void record_dynamic_extents (const region2 *reg,
-			       const svalue2 *size_in_bytes);
+  void record_dynamic_extents (const region *reg,
+			       const svalue *size_in_bytes);
 
   /* Storing this here to avoid passing it around everywhere.  */
-  region_model2_manager *const m_mgr;
+  region_model_manager *const m_mgr;
 
   store m_store;
 
-  constraint_manager2 *m_constraints2; // TODO: embed, rather than dynalloc?
+  constraint_manager *m_constraints; // TODO: embed, rather than dynalloc?
 
-  const frame_region2 *m_current_frame;
+  const frame_region *m_current_frame;
 };
 
-/* Some region_model2 activity could lead to warnings (e.g. attempts to use an
+/* Some region_model activity could lead to warnings (e.g. attempts to use an
    uninitialized value).  This abstract base class encapsulates an interface
-   for the region2 model to use when emitting such warnings.
-
-   It also provides an interface for being notified about svalue2_ids being
-   remapped, and being deleted.
+   for the region model to use when emitting such warnings.
 
    Having this as an abstract base class allows us to support the various
-   operations needed by program_state in the analyzer within region_model2,
+   operations needed by program_state in the analyzer within region_model,
    whilst keeping them somewhat modularized.  */
 
-class region_model2_context
+class region_model_context
 {
  public:
   virtual void warn (pending_diagnostic *d) = 0;
 
-#if 0
-  /* Return true if if's OK to purge SID when simplifying state.
-     Subclasses can return false for values that have sm state,
-     to avoid generating "leak" false positives.  */
-  virtual bool can_purge_p (svalue2_id sid) = 0;
-#endif
-
   // FIXME:
   /* Hook for clients to be notified when a range of SIDs have
      been purged, so that they can purge state relating to those
@@ -2859,35 +2745,19 @@ class region_model2_context
      has purged (potentially for use in selftests).
      MAP has already been applied to the IDs, but is provided in case
      the client needs to figure out the old IDs.  */
-  virtual void on_svalue2_leak (const svalue2 *sval) = 0;
+  virtual void on_svalue_leak (const svalue *sval) = 0;
 
   /* Hook for clients to be notified when the set of explicitly live
-     svalue2s changes, so that they can purge state relating to dead
+     svalues changes, so that they can purge state relating to dead
      svalues.  */
   virtual void
-  on_liveness_change (const svalue2_set &live_svalues,
-		      const region_model2 *model) = 0;
+  on_liveness_change (const svalue_set &live_svalues,
+		      const region_model *model) = 0;
 
   virtual logger *get_logger () = 0;
 
-#if 0
-  /* Hook for clients to be notified when CHILD_SID is created
-     from PARENT_SID, when "inheriting" a value for a region2 from a
-     parent region2.
-     This exists so that state machines that inherit state can
-     propagate the state from parent to child.  */
-  virtual void on_inherited_svalue2 (svalue2_id parent_sid,
-				    svalue2_id child_sid) = 0;
-
-  /* Hook for clients to be notified when DST_SID is created
-     (or reused) as a cast from SRC_SID.
-     This exists so that state machines can propagate the state
-     from SRC_SID to DST_SID.  */
-  virtual void on_cast (svalue2_id src_sid,
-			svalue2_id dst_sid) = 0;
-#endif
   /* Hook for clients to be notified when the condition
-     "LHS OP RHS" is added to the region2 model.
+     "LHS OP RHS" is added to the region model.
      This exists so that state machines can detect tests on edges,
      and use them to trigger sm-state transitions (e.g. transitions due
      to ptrs becoming known to be NULL or non-NULL, rather than just
@@ -2897,45 +2767,34 @@ class region_model2_context
   // FIXME:
   /* Hooks for clients to be notified when an unknown change happens
      to BASE_REG (in response to a call to an unknown function).  */
-  virtual void on_unknown_change (const svalue2 *sval, bool is_mutable) = 0;
+  virtual void on_unknown_change (const svalue *sval, bool is_mutable) = 0;
 
   /* Hooks for clients to be notified when a phi node is handled,
      where RHS is the pertinent argument.  */
   virtual void on_phi (const gphi *phi, tree rhs) = 0;
 
-  /* Hooks for clients to be notified when the region2 model doesn't
+  /* Hooks for clients to be notified when the region model doesn't
      know how to handle the tree code of T at LOC.  */
   virtual void on_unexpected_tree_code (tree t,
 					const dump_location_t &loc) = 0;
 };
 
-/* A "do nothing" subclass of region_model2_context.  */
+/* A "do nothing" subclass of region_model_context.  */
 
-class noop_region_model2_context : public region_model2_context
+class noop_region_model_context : public region_model_context
 {
 public:
   void warn (pending_diagnostic *) OVERRIDE {}
-  void on_svalue2_leak (const svalue2 *) OVERRIDE {}
-  void on_liveness_change (const svalue2_set &,
-			   const region_model2 *) OVERRIDE {}
+  void on_svalue_leak (const svalue *) OVERRIDE {}
+  void on_liveness_change (const svalue_set &,
+			   const region_model *) OVERRIDE {}
   logger *get_logger () OVERRIDE { return NULL; }
-#if 0
-  void on_inherited_svalue2 (svalue2_id parent_sid ATTRIBUTE_UNUSED,
-			    svalue2_id child_sid  ATTRIBUTE_UNUSED)
-    OVERRIDE
-  {
-  }
-  void on_cast (svalue2_id src_sid ATTRIBUTE_UNUSED,
-		svalue2_id dst_sid ATTRIBUTE_UNUSED) OVERRIDE
-  {
-  }
-#endif
   void on_condition (tree lhs ATTRIBUTE_UNUSED,
 		     enum tree_code op ATTRIBUTE_UNUSED,
 		     tree rhs ATTRIBUTE_UNUSED) OVERRIDE
   {
   }
-  void on_unknown_change (const svalue2 *sval ATTRIBUTE_UNUSED,
+  void on_unknown_change (const svalue *sval ATTRIBUTE_UNUSED,
 			  bool is_mutable ATTRIBUTE_UNUSED) OVERRIDE
   {
   }
@@ -2946,13 +2805,13 @@ public:
   void on_unexpected_tree_code (tree, const dump_location_t &) OVERRIDE {}
 };
 
-/* A subclass of region_model2_context for determining if operations fail
-   e.g. "can we generate a region2 for the lvalue of EXPR?".  */
+/* A subclass of region_model_context for determining if operations fail
+   e.g. "can we generate a region for the lvalue of EXPR?".  */
 
-class tentative_region_model2_context : public noop_region_model2_context
+class tentative_region_model_context : public noop_region_model_context
 {
 public:
-  tentative_region_model2_context () : m_num_unexpected_codes (0) {}
+  tentative_region_model_context () : m_num_unexpected_codes (0) {}
 
   void on_unexpected_tree_code (tree, const dump_location_t &)
     FINAL OVERRIDE
@@ -2966,15 +2825,15 @@ private:
   int m_num_unexpected_codes;
 };
 
-/* A bundle of data for use when attempting to merge two region_model2
+/* A bundle of data for use when attempting to merge two region_model
    instances to make a third.  */
 
-struct model2_merger
+struct model_merger
 {
-  model2_merger (const region_model2 *model_a,
-		 const region_model2 *model_b,
+  model_merger (const region_model *model_a,
+		 const region_model *model_b,
 		 const program_point &point,
-		 region_model2 *merged_model)
+		 region_model *merged_model)
   : m_model_a (model_a), m_model_b (model_b),
     m_point (point),
     m_merged_model (merged_model)
